"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __exportStar = (this && this.__exportStar) || function(m, exports) {
    for (var p in m) if (p !== "default" && !Object.prototype.hasOwnProperty.call(exports, p)) __createBinding(exports, m, p);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getGameMetainfo = exports.getGameMaps = exports.getServerStats = exports.getAllTimeLeaderboard = exports.getSpecialLeaderboard = exports.getSeasonLeaderboard = exports.getMonthlyLeaderboard = exports.getMainStats = exports.getGameAllTimeStats = exports.getAllTimeStats = exports.getGameSeasonStats = exports.getGameMonthlyStats = exports.getMonthlyStats = exports.setHiveApiUrl = exports.getHiveApiUrl = void 0;
var data_1 = require("./games/data");
var info_1 = require("./games/info");
var processors_1 = require("./games/processors");
var cachedResponses = {};
var hiveApiUrl = "https://api.playhive.com/v0";
function getHiveApiUrl() {
    return hiveApiUrl;
}
exports.getHiveApiUrl = getHiveApiUrl;
function setHiveApiUrl(url) {
    hiveApiUrl = url;
}
exports.setHiveApiUrl = setHiveApiUrl;
function fetchData(url, controller, init) {
    return __awaiter(this, void 0, void 0, function () {
        var data;
        var _this = this;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    if (!cachedResponses[url]) return [3 /*break*/, 3];
                    if (!(Date.now() - cachedResponses[url].time < 5 * 60 * 1000)) return [3 /*break*/, 2];
                    return [4 /*yield*/, cachedResponses[url].response.catch(function (e) { return __awaiter(_this, void 0, void 0, function () {
                            return __generator(this, function (_a) {
                                switch (_a.label) {
                                    case 0:
                                        //Assume if the request errored out and the AbortController was aborted, that was the reason for the error,
                                        //and that this new request is using a new AbortController and should continue.
                                        if (e.name !== "AbortError")
                                            throw e;
                                        return [4 /*yield*/, fetchData(url)];
                                    case 1: return [2 /*return*/, _a.sent()];
                                }
                            });
                        }); })];
                case 1: return [2 /*return*/, _a.sent()];
                case 2:
                    delete cachedResponses[url];
                    _a.label = 3;
                case 3:
                    cachedResponses[url] = {
                        response: fetch(hiveApiUrl + url, __assign(__assign({}, init), { signal: controller === null || controller === void 0 ? void 0 : controller.signal, headers: __assign({ "X-Hive-Api-Version": "2024-03-29" }, init === null || init === void 0 ? void 0 : init.headers) }))
                            .then(function (response) { return __awaiter(_this, void 0, void 0, function () {
                            var timeout;
                            var _a;
                            return __generator(this, function (_b) {
                                switch (_b.label) {
                                    case 0:
                                        if (response.ok)
                                            return [2 /*return*/, response.json()];
                                        timeout = (_a = response.headers.get("retry-after")) !== null && _a !== void 0 ? _a : "60";
                                        if (response.status !== 429)
                                            throw new Error(response.statusText);
                                        return [4 /*yield*/, new Promise(function (r) { return setTimeout(r, parseInt(timeout) * 1000); })];
                                    case 1:
                                        _b.sent();
                                        delete cachedResponses[url];
                                        return [4 /*yield*/, fetchData(url, controller)];
                                    case 2: return [2 /*return*/, _b.sent()];
                                }
                            });
                        }); })
                            .catch(function (e) {
                            delete cachedResponses[url];
                            throw e;
                        }),
                        time: Date.now()
                    };
                    return [4 /*yield*/, cachedResponses[url].response];
                case 4:
                    data = _a.sent();
                    cachedResponses[url].time = Date.now();
                    return [2 /*return*/, data];
            }
        });
    });
}
function validateMonth(game, year, month) {
    if (year === undefined || month === undefined)
        return;
    var _a = info_1.GameLeaderboardInfo[game].epoch, epochYear = _a.year, epochMonth = _a.month;
    if (year < epochYear || (year === epochYear && month < epochMonth)) {
        throw new Error("Can not access ".concat(game, " monthly statistics for month (").concat(month, "/").concat(year, ") prior to epoch (").concat(epochMonth, "/").concat(epochYear, ")."));
    }
    if (info_1.GameLeaderboardInfo[game].archived) {
        var _b = info_1.GameLeaderboardInfo[game].archived, archivedYear = _b.year, archivedMonth = _b.month;
        if (year > archivedYear ||
            (year === archivedYear && month > archivedMonth)) {
            throw new Error("Can not access ".concat(game, " monthly statistics for month (").concat(month, "/").concat(year, ") after archival (").concat(archivedMonth, "/").concat(archivedYear, ")."));
        }
    }
}
function getMonthlyStats(identifier, year, month, controller, init) {
    return __awaiter(this, void 0, void 0, function () {
        var url, data;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    validateMonth(data_1.Game.TreasureWars, year, month);
                    url = "/game/monthly/player/all/".concat(identifier);
                    if (year && month)
                        url += "/".concat(year, "/").concat(month);
                    return [4 /*yield*/, fetchData(url, controller, init)];
                case 1:
                    data = _a.sent();
                    Object.values(data_1.Game).forEach(function (game) {
                        var stats = data[game];
                        if (!stats || Array.isArray(stats) || stats.human_index === 2147483647) {
                            data[game] = null;
                            return;
                        }
                        processors_1.MonthlyStatsProcessors[game].forEach(function (processor) { return processor(stats); });
                    });
                    return [2 /*return*/, data];
            }
        });
    });
}
exports.getMonthlyStats = getMonthlyStats;
function getGameMonthlyStats(identifier, game, year, month, controller, init) {
    return __awaiter(this, void 0, void 0, function () {
        var url, data;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    validateMonth(game, year, month);
                    url = "/game/monthly/player/".concat(game, "/").concat(identifier);
                    if (year && month)
                        url += "/".concat(year, "/").concat(month);
                    return [4 /*yield*/, fetchData(url, controller, init)];
                case 1:
                    data = _a.sent();
                    processors_1.MonthlyStatsProcessors[game].forEach(function (processor) { return processor(data); });
                    return [2 /*return*/, data];
            }
        });
    });
}
exports.getGameMonthlyStats = getGameMonthlyStats;
function getGameSeasonStats(identifier, game, season, controller, init) {
    return __awaiter(this, void 0, void 0, function () {
        var url, data;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    url = "/game/season/player/".concat(game, "/").concat(identifier, "/").concat(season);
                    return [4 /*yield*/, fetchData(url, controller, init)];
                case 1:
                    data = _a.sent();
                    processors_1.MonthlyStatsProcessors[game].forEach(function (processor) { return processor(data); });
                    return [2 /*return*/, data];
            }
        });
    });
}
exports.getGameSeasonStats = getGameSeasonStats;
function getAllTimeStats(identifier, controller, init) {
    return __awaiter(this, void 0, void 0, function () {
        var data;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, fetchData("/game/all/all/".concat(identifier), controller, init)];
                case 1:
                    data = _a.sent();
                    Object.values(data_1.Game).forEach(function (game) {
                        var stats = data[game];
                        if (!stats || Array.isArray(stats)) {
                            data[game] = null;
                            return;
                        }
                        processors_1.AllTimeStatsProcessors[game].forEach(function (processor) {
                            return processor(stats);
                        });
                    });
                    return [2 /*return*/, data];
            }
        });
    });
}
exports.getAllTimeStats = getAllTimeStats;
function getGameAllTimeStats(identifier, game, controller, init) {
    return __awaiter(this, void 0, void 0, function () {
        var data;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, fetchData("/game/all/".concat(game, "/").concat(identifier), controller, init)];
                case 1:
                    data = _a.sent();
                    processors_1.AllTimeStatsProcessors[game].forEach(function (processor) { return processor(data); });
                    return [2 /*return*/, data];
            }
        });
    });
}
exports.getGameAllTimeStats = getGameAllTimeStats;
function getMainStats(identifier, controller, init) {
    return __awaiter(this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, fetchData("/game/all/all/".concat(identifier), controller, init)];
                case 1: return [2 /*return*/, (_a.sent())["main"]];
            }
        });
    });
}
exports.getMainStats = getMainStats;
function getMonthlyLeaderboard(game, year, month, amount, skip, controller, init) {
    return __awaiter(this, void 0, void 0, function () {
        var url, data, _a, _b;
        return __generator(this, function (_c) {
            switch (_c.label) {
                case 0:
                    validateMonth(game, year, month);
                    url = "/game/monthly/".concat(game);
                    if (year && month) {
                        url += "/".concat(year, "/").concat(month);
                        if (amount) {
                            url += "/".concat(amount);
                            if (skip)
                                url += "/".concat(skip);
                        }
                    }
                    _b = (_a = Object).values;
                    return [4 /*yield*/, fetchData(url, controller, init)];
                case 1:
                    data = _b.apply(_a, [_c.sent()]);
                    processors_1.MonthlyStatsProcessors[game].forEach(function (processor) {
                        return data.forEach(function (d) { return processor(d); });
                    });
                    return [2 /*return*/, data];
            }
        });
    });
}
exports.getMonthlyLeaderboard = getMonthlyLeaderboard;
function getSeasonLeaderboard(game, season, amount, skip, controller, init) {
    return __awaiter(this, void 0, void 0, function () {
        var url, data, _a, _b;
        return __generator(this, function (_c) {
            switch (_c.label) {
                case 0:
                    url = "/game/season/".concat(game, "/").concat(season);
                    if (amount) {
                        if (!skip)
                            skip = 0;
                        url += "/".concat(amount, "/").concat(skip);
                    }
                    _b = (_a = Object).values;
                    return [4 /*yield*/, fetchData(url, controller, init)];
                case 1:
                    data = _b.apply(_a, [_c.sent()]);
                    processors_1.MonthlyStatsProcessors[game].forEach(function (processor) {
                        return data.forEach(function (d) { return processor(d); });
                    });
                    return [2 /*return*/, data];
            }
        });
    });
}
exports.getSeasonLeaderboard = getSeasonLeaderboard;
function getSpecialLeaderboard(game, leaderboardName, amount, skip, controller, init) {
    return __awaiter(this, void 0, void 0, function () {
        var url, data, _a, _b;
        return __generator(this, function (_c) {
            switch (_c.label) {
                case 0:
                    url = "/game/special/".concat(game, "/").concat(leaderboardName);
                    if (amount) {
                        if (!skip)
                            skip = 0;
                        url += "/".concat(amount, "/").concat(skip);
                    }
                    _b = (_a = Object).values;
                    return [4 /*yield*/, fetchData(url, controller, init)];
                case 1:
                    data = _b.apply(_a, [_c.sent()]);
                    processors_1.MonthlyStatsProcessors[game].forEach(function (processor) {
                        return data.forEach(function (d) { return processor(d); });
                    });
                    return [2 /*return*/, data];
            }
        });
    });
}
exports.getSpecialLeaderboard = getSpecialLeaderboard;
function getAllTimeLeaderboard(game, controller, init) {
    return __awaiter(this, void 0, void 0, function () {
        var data;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, fetchData("/game/all/".concat(game), controller, init)];
                case 1:
                    data = _a.sent();
                    processors_1.AllTimeStatsProcessors[game].forEach(function (processor) {
                        return data.forEach(function (d) { return processor(d); });
                    });
                    return [2 /*return*/, data];
            }
        });
    });
}
exports.getAllTimeLeaderboard = getAllTimeLeaderboard;
function getServerStats(controller, init) {
    return __awaiter(this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, fetchData("/global/statistics", controller, init)];
                case 1: return [2 /*return*/, _a.sent()];
            }
        });
    });
}
exports.getServerStats = getServerStats;
function getGameMaps(game, controller, init) {
    return __awaiter(this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, fetchData("/game/map/".concat(game), controller, init)];
                case 1: return [2 /*return*/, _a.sent()];
            }
        });
    });
}
exports.getGameMaps = getGameMaps;
function getGameMetainfo(game, controller, init) {
    return __awaiter(this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, fetchData("/game/meta/".concat(game), controller, init)];
                case 1: return [2 /*return*/, _a.sent()];
            }
        });
    });
}
exports.getGameMetainfo = getGameMetainfo;
__exportStar(require("./games/data"), exports);
__exportStar(require("./games/info"), exports);
__exportStar(require("./games/processors"), exports);
__exportStar(require("./map/data"), exports);
__exportStar(require("./player/data"), exports);
//# sourceMappingURL=index.js.map